OGRE: Ogre::RenderWindow Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::RenderWindow Class Referenceabstract
Core » RenderSystem

Manages the target rendering window. More...

`#include <OgreRenderWindow.h>`

Inheritance diagram for Ogre::RenderWindow:
[legend]

## Public Member Functions
| RenderWindow ()
| Default constructor.
virtual void | create (const String &name, unsigned int widthPt, unsigned int heightPt, bool fullScreen, const NameValuePairList *miscParams)=0
| Creates & displays the new window.
virtual void | destroy (void)=0
| Destroys the window.
void | getMetrics (unsigned int &width, unsigned int &height, int &left, int &top) const
| Overloaded version of getMetrics from RenderTarget, including extra details specific to windowing systems.
virtual float | getViewPointToPixelScale ()
| Many windowing systems that support HiDPI displays use special points to specify size of the windows and controls, so that windows and controls with hardcoded sizes does not become too small on HiDPI displays.
unsigned int | getVSyncInterval () const
| Returns the vertical sync interval.
bool | isActive (void) const override
| Overridden from RenderTarget, flags invisible windows as inactive.
virtual bool | isClosed (void) const
| Indicates whether the window has been closed by the user.
bool | isDeactivatedOnFocusChange () const
| Returns true if the window will automatically de-activate itself when it loses focus.
virtual bool | isFullScreen (void) const
| Returns true if window is running in fullscreen mode.
virtual bool | isHidden (void) const
| Indicates whether the window was set to hidden (not displayed).
bool | isPrimary (void) const override
| Indicates whether the window is the primary window.
virtual bool | isVisible (void) const
| Indicates whether the window is visible (not minimized or obscured).
virtual bool | isVSyncEnabled () const
| Indicates whether vertical sync is activated for the window.
virtual void | reposition (int leftPt, int topPt)
| Reposition the window.
virtual void | resize (unsigned int widthPt, unsigned int heightPt)
| Alter the size of the window.
void | setDeactivateOnFocusChange (bool deactivate)
| Indicates whether the window will automatically deactivate itself when it loses focus.
virtual void | setFullscreen (bool fullScreen, unsigned int widthPt, unsigned int heightPt)
| Alter fullscreen mode options.
virtual void | setHidden (bool hidden)
| Hide (or show) the window.
virtual void | setVisible (bool visible)
| Set the visibility state.
virtual void | setVSyncEnabled (bool vsync)
| Enable or disable vertical sync for the RenderWindow.
virtual void | setVSyncInterval (unsigned int interval)
| Set the vertical sync interval.
PixelFormat | suggestPixelFormat () const override
| Override since windows don't usually have alpha.
virtual void | windowMovedOrResized ()
| Query the current size and position from an external window handle.
Public Member Functions inherited from Ogre::RenderTarget
| RenderTarget ()
virtual | ~RenderTarget ()
virtual void | _beginUpdate ()
| Method for manual management of rendering : fires 'preRenderTargetUpdate' and initialises statistics etc.
virtual void | _detachDepthBuffer ()
| Detaches DepthBuffer without notifying it from the detach.
virtual void | _endUpdate ()
| Method for manual management of rendering - finishes statistics calculation and fires 'postRenderTargetUpdate'.
void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify a render target that a camera has been removed, in case it was referring to it as a viewer.
void | _updateAutoUpdatedViewports (bool updateStatistics=true)
| Method for manual management of rendering - renders only viewports that are auto updated.
void | _updateViewport (int zorder, bool updateStatistics=true)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).
virtual void | _updateViewport (Viewport *viewport, bool updateStatistics=true)
| Method for manual management of rendering - renders the given viewport (even if it is not autoupdated).
void | addListener (RenderTargetListener *listener)
| Add a listener to this RenderTarget which will be called back before & after rendering.
Viewport * | addViewport (Camera *cam, int ZOrder, float left, float top=0.0f, float width=1.0f, float height=1.0f)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Viewport * | addViewport (Camera *cam, int ZOrder=0, FloatRect rect={0.0f, 0.0f, 1.0f, 1.0f})
| Adds a viewport to the rendering target.
virtual bool | attachDepthBuffer (DepthBuffer *depthBuffer)
virtual void | copyContentsToMemory (const Box &src, const PixelBox &dst, FrameBuffer buffer=FB_AUTO)=0
| Copies the current contents of the render target to a pixelbox.
void | copyContentsToMemory (const PixelBox &dst, FrameBuffer buffer=FB_AUTO)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | detachDepthBuffer ()
uint | getCustomAttribute (const String &name)
| simplified API for bindings
virtual void | getCustomAttribute (const String &name, void *pData)
| Retrieve a platform or API-specific piece of information.
DepthBuffer * | getDepthBuffer () const
uint16 | getDepthBufferPool () const
uint | getFSAA () const
| Indicates whether multisampling is performed on rendering and at what level.
const String & | getFSAAHint () const
| RenderSystem specific FSAA option. See RenderSystem::_createRenderWindow for details.
uint32 | getHeight (void) const
void | getMetrics (unsigned int &width, unsigned int &height)
| Retrieve information about the render target.
const String & | getName (void) const
| Retrieve target's name.
unsigned short | getNumViewports (void) const
| Returns the number of viewports attached to this target.
uchar | getPriority () const
| Gets the priority of a render target.
const FrameStats & | getStatistics (void) const
| Retrieves details of current rendering performance.
Viewport * | getViewport (unsigned short index)
| Retrieves a pointer to the viewport with the given index.
Viewport * | getViewportByZOrder (int ZOrder)
| Retrieves a pointer to the viewport with the given Z-order.
uint32 | getWidth (void) const
bool | hasViewportWithZOrder (int ZOrder)
| Returns true if and only if a viewport exists at the given Z-order.
void | insertListener (RenderTargetListener *listener, const unsigned int pos=0)
| same as addListener, but force the position in the vector, so we can control the call order
bool | isAutoUpdated (void) const
| Gets whether this target is automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
bool | isHardwareGammaEnabled () const
| Indicates whether on rendering, linear colour space is converted to sRGB gamma colour space.
virtual bool | isStereoEnabled (void) const
| Indicates whether stereo is currently enabled for this target.
void | removeAllListeners (void)
| Removes all listeners from this instance.
void | removeAllViewports (void)
| Removes all viewports on this target.
void | removeListener (RenderTargetListener *listener)
| Removes a RenderTargetListener previously registered using addListener.
void | removeViewport (int ZOrder)
| Removes a viewport at a given Z-order.
virtual bool | requiresTextureFlipping () const =0
void | resetStatistics (void)
| Resets saved frame-rate statistices.
void | setActive (bool state)
| Used to set the active state of the render target.
void | setAutoUpdated (bool autoupdate)
| Sets whether this target should be automatically updated if Ogre's rendering loop or Root::_updateAllRenderTargets is being used.
void | setDepthBufferPool (uint16 poolId)
| Sets the pool ID this RenderTarget should query from.
virtual void | setFSAA (uint fsaa, const String &fsaaHint)
| Set the level of multisample AA to be used if hardware support it.
void | setPriority (uchar priority)
| Sets the priority of this render target in relation to the others.
virtual void | swapBuffers ()
| Finalizes the frame by performing buffer swaps and MSAA resolves.
void | update (bool swapBuffers=true)
| Tells the target to update it's contents.
void | writeContentsToFile (const String &filename)
| Writes the current contents of the render target to the named file.
String | writeContentsToTimestampedFile (const String &filenamePrefix, const String &filenameSuffix)
| Writes the current contents of the render target to the (PREFIX)(time-stamp)(SUFFIX) file.

## Additional Inherited Members
Public Types inherited from Ogre::RenderTarget
enum | FrameBuffer { FB_FRONT , FB_BACK , FB_AUTO }

## Detailed Description

Manages the target rendering window.

This class handles a window into which the contents of a scene are rendered. There is a many-to-1 relationship between instances of this class an instance of RenderSystem which controls the rendering of the scene. There may be more than one window in the case of level editor tools etc. This class is abstract since there may be different implementations for different windowing systems.

Instances are created and communicated with by the render system although client programs can get a reference to it from the render system if required for resizing or moving. Note that you can have multiple viewpoints in the window for effects like rear-view mirrors and picture-in-picture views (see Viewport and Camera).

Author
  Steven Streeting

## Constructor & Destructor Documentation

## ◆ RenderWindow()

Ogre::RenderWindow::RenderWindow | ( |  | ) |

Default constructor.

## Member Function Documentation

## ◆ getViewPointToPixelScale()

virtual float Ogre::RenderWindow::getViewPointToPixelScale | ( |  | ) |
| inlinevirtual

Many windowing systems that support HiDPI displays use special points to specify size of the windows and controls, so that windows and controls with hardcoded sizes does not become too small on HiDPI displays.

Such points have constant density ~ 100 points per inch (probably 96 on Windows and 72 on Mac), that is independent of pixel density of real display, and are used through the all windowing system.

Sometimes, such view points are chosen bigger for output devices that are viewed from larger distances, like 30" TV comparing to 30" monitor, therefore maintaining constant points angular density rather than constant linear density.

In any case, all such windowing system provides the way to convert such view points to pixels, be it DisplayProperties::LogicalDpi on WinRT or backingScaleFactor on MacOSX. We use pixels consistently through the Ogre, but window/view management functions takes view points for convenience, as does the rest of windowing system. Such parameters are named using xxxxPt pattern, and should not be mixed with pixels without being converted using getViewPointToPixelScale() function.

Sometimes such scale factor can change on-the-fly, for example if window is dragged to monitor with different DPI. In such situation, window size in view points is usually preserved by windowing system, and Ogre should adjust pixel size of RenderWindow.

## ◆ create()

virtual void Ogre::RenderWindow::create | ( | const String & | name,
|  | unsigned int | widthPt,
|  | unsigned int | heightPt,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams )
| pure virtual

Creates & displays the new window.

Parameters

  name | the internal window name. Not necessarily the title.
  widthPt | The width of the window in view points.
  heightPt | The height of the window in view points.
  fullScreen | If true, the window fills the screen, with no title bar or border.
  miscParams | A variable number of pointers to platform-specific arguments. The actual requirements must be defined by the implementing subclasses.

## ◆ setFullscreen()

virtual void Ogre::RenderWindow::setFullscreen | ( | bool | fullScreen,
|  | unsigned int | widthPt,
|  | unsigned int | heightPt )
| inlinevirtual

Alter fullscreen mode options.

Nothing will happen unless the settings here are different from the current settings.

Note
  Only implemented by few RenderSystems. Prefer native windowing API.

Parameters

  fullScreen | Whether to use fullscreen mode or not.
  widthPt | The new width to use
  heightPt | The new height to use

## ◆ destroy()

virtual void Ogre::RenderWindow::destroy | ( | void |  | ) |
| pure virtual

Destroys the window.

## ◆ resize()

virtual void Ogre::RenderWindow::resize | ( | unsigned int | widthPt,
|  | unsigned int | heightPt )
| virtual

Alter the size of the window.

## ◆ windowMovedOrResized()

virtual void Ogre::RenderWindow::windowMovedOrResized | ( |  | ) |
| inlinevirtual

Query the current size and position from an external window handle.

Note
  most of the time you already know the size and should call resize instead.

## ◆ reposition()

virtual void Ogre::RenderWindow::reposition | ( | int | leftPt,
|  | int | topPt )
| inlinevirtual

Reposition the window.

Note
  Only implemented by few RenderSystems. Prefer native windowing API.

## ◆ isVisible()

virtual bool Ogre::RenderWindow::isVisible | ( | void |  | ) | const
| inlinevirtual

Indicates whether the window is visible (not minimized or obscured).

Referenced by isActive().

## ◆ setVisible()

virtual void Ogre::RenderWindow::setVisible | ( | bool | visible | ) |
| inlinevirtual

Set the visibility state.

## ◆ isHidden()

virtual bool Ogre::RenderWindow::isHidden | ( | void |  | ) | const
| inlinevirtual

Indicates whether the window was set to hidden (not displayed).

## ◆ setHidden()

virtual void Ogre::RenderWindow::setHidden | ( | bool | hidden | ) |
| inlinevirtual

Hide (or show) the window.

If called with hidden=true, this will make the window completely invisible to the user.

Setting a window to hidden is useful to create a dummy primary RenderWindow hidden from the user so that you can create and recreate your actual RenderWindows without having to recreate all your resources.

## ◆ setVSyncEnabled()

virtual void Ogre::RenderWindow::setVSyncEnabled | ( | bool | vsync | ) |
| inlinevirtual

Enable or disable vertical sync for the RenderWindow.

## ◆ isVSyncEnabled()

virtual bool Ogre::RenderWindow::isVSyncEnabled | ( |  | ) | const
| inlinevirtual

Indicates whether vertical sync is activated for the window.

## ◆ setVSyncInterval()

virtual void Ogre::RenderWindow::setVSyncInterval | ( | unsigned int | interval | ) |
| inlinevirtual

Set the vertical sync interval.

This indicates the number of vertical retraces to wait for before swapping buffers. A value of 1 is the default.

## ◆ getVSyncInterval()

unsigned int Ogre::RenderWindow::getVSyncInterval | ( |  | ) | const
| inline

Returns the vertical sync interval.

## ◆ isActive()

bool Ogre::RenderWindow::isActive | ( | void |  | ) | const
| inlineoverridevirtual

Overridden from RenderTarget, flags invisible windows as inactive.

Reimplemented from Ogre::RenderTarget.

References isVisible().

## ◆ isClosed()

virtual bool Ogre::RenderWindow::isClosed | ( | void |  | ) | const
| inlinevirtual

Indicates whether the window has been closed by the user.

## ◆ isPrimary()

bool Ogre::RenderWindow::isPrimary | ( | void |  | ) | const
| overridevirtual

Indicates whether the window is the primary window.

The primary window is special in that it is destroyed when ogre is shut down, and cannot be destroyed directly. This is the case because it holds the context for vertex, index buffers and textures.

Reimplemented from Ogre::RenderTarget.

## ◆ isFullScreen()

virtual bool Ogre::RenderWindow::isFullScreen | ( | void |  | ) | const
| virtual

Returns true if window is running in fullscreen mode.

## ◆ getMetrics()

void Ogre::RenderWindow::getMetrics | ( | unsigned int & | width,
|  | unsigned int & | height,
|  | int & | left,
|  | int & | top ) const

Overloaded version of getMetrics from RenderTarget, including extra details specific to windowing systems.

Result is in pixels.

## ◆ suggestPixelFormat()

PixelFormat Ogre::RenderWindow::suggestPixelFormat | ( |  | ) | const
| inlineoverridevirtual

Override since windows don't usually have alpha.

Reimplemented from Ogre::RenderTarget.

References Ogre::PF_BYTE_RGB.

## ◆ isDeactivatedOnFocusChange()

bool Ogre::RenderWindow::isDeactivatedOnFocusChange | ( |  | ) | const

Returns true if the window will automatically de-activate itself when it loses focus.

## ◆ setDeactivateOnFocusChange()

void Ogre::RenderWindow::setDeactivateOnFocusChange | ( | bool | deactivate | ) |

Indicates whether the window will automatically deactivate itself when it loses focus.

Parameters

  deactivate | a value of 'true' will cause the window to deactivate itself when it loses focus. 'false' will allow it to continue to render even when window focus is lost.

Note
  'true' is the default behavior.

The documentation for this class was generated from the following file:

- OgreRenderWindow.h